### Proxmox, подключение физического жесткого диска в виртуальную машину

1. В общем случае это можно сделать одной простой командой:
```
qm set <vm_id> -[virtio|sata|ide|scsi][№] /dev/sd[a|b|c|...]
```
где:
```
vm_id                        — номер виртуальной машины (в интерфейсе Proxmox указывается перед именем VM
-[virtio|sata|ide|scsi][№]   — допустимый тип и номер HDD интерфейса
/dev/sd[a|b|c…]              — пробрасывоемое физическое устройство
```
**Но при таком подходе может случится, что в систему прокинется не тот диск, если перепутать порты на материнской
плате, поэтому гораздо эффективней пробросить устройство по его id.**

Найдем id нашего диска:
```
ls -l /dev/disk/by-id/
```

```
da2001@Metromint:~$ ls -l /dev/disk/by-id/
итого 0
lrwxrwxrwx 1 root root  9 июн  9 09:58 ata-ST1000LM035-1RK172_ZDEH8TVK -> ../../sda
lrwxrwxrwx 1 root root 10 июн  9 09:58 ata-ST1000LM035-1RK172_ZDEH8TVK-part1 -> ../../sda1
lrwxrwxrwx 1 root root 10 июн  9 09:58 ata-ST1000LM035-1RK172_ZDEH8TVK-part2 -> ../../sda2
lrwxrwxrwx 1 root root 10 июн  9 09:58 ata-ST1000LM035-1RK172_ZDEH8TVK-part3 -> ../../sda3
lrwxrwxrwx 1 root root 13 июн  9 09:58 nvme-HFM256GDJTNG-8310A_NJ93N253310403M4A -> ../../nvme0n1
lrwxrwxrwx 1 root root 15 июн  9 09:58 nvme-HFM256GDJTNG-8310A_NJ93N253310403M4A-part1 -> ../../nvme0n1p1
lrwxrwxrwx 1 root root 15 июн  9 09:58 nvme-HFM256GDJTNG-8310A_NJ93N253310403M4A-part3 -> ../../nvme0n1p3
lrwxrwxrwx 1 root root 15 июн  9 09:58 nvme-HFM256GDJTNG-8310A_NJ93N253310403M4A-part4 -> ../../nvme0n1p4
```

```
qm set 150 -virtio2 /dev/disk/by-id/ata-ST1000LM035-1RK172_ZDEH8TVK
```

2. Прописать в конфигурационный файл
*конфигурационные файлы виртуальных машин лежат по пути*
```
/etc/pve/qemu-server
```

```
root@pve:/etc/pve/qemu-server# ls -l
итого 6
-rw-r----- 1 root www-data 851 июн  9 13:06 100.conf
-rw-r----- 1 root www-data 504 янв 10 12:11 101.conf
-rw-r----- 1 root www-data 490 янв 17 11:51 102.conf
-rw-r----- 1 root www-data 310 июн  8 02:27 103.conf
-rw-r----- 1 root www-data 544 июн  9 13:06 104.conf
-rw-r----- 1 root www-data 333 мар 29 10:08 105.conf
-rw-r----- 1 root www-data 344 июн  8 02:34 106.conf
-rw-r----- 1 root www-data 731 июн  9 13:06 107.conf
-rw-r----- 1 root www-data 334 мая 14 09:16 108.conf
-rw-r----- 1 root www-data 368 июл 28  2020 109.conf
-rw-r----- 1 root www-data 330 июн  8 20:24 110.conf
-rw-r----- 1 root www-data 588 июн  9 13:06 112.conf
```
Выбираем необходимую виртуалку
```
vi 100.conf
```
Добавляем нужный диск
```
scsi1: /dev/disk/by-id/ata-ST2000VN000-1HJ164_W7200J60,backup=0
```

```
agent: 1,fstrim_cloned_disks=1
boot: cdn
bootdisk: scsi0
cores: 2
ide2: none,media=cdrom
memory: 4096
name: S-DNAS
net0: virtio=F6:79:BA:89:90:D5,bridge=vmbr0,firewall=1
numa: 0
onboot: 1
ostype: l26
protection: 1
scsi0: local-lvm:vm-100-disk-0,size=32G
scsi1: /dev/disk/by-id/ata-ST2000VN000-1HJ164_W7200J60,backup=0
scsi2: /dev/disk/by-id/ata-ST2000VN000-1HJ164_W7201D04,backup=0
scsihw: virtio-scsi-pci
smbios1: uuid=0a43c8e8-33f0-4472-9508-2b4b3d3c196f
sockets: 1
spice_enhancements: foldersharing=1
vga: qxl
vmgenid: 2d5bb546-186a-4b01-b469-94f3c56224be
```